> ## Documentation Index
> Fetch the complete documentation index at: https://docs.portkey.ai/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# F5 Guardrails

> F5 Guardrails (powered by CalypsoAI) provides advanced content moderation and PII detection capabilities for your LLM inputs and outputs.

[F5 Guardrails](https://calypsoai.com/) (formerly CalypsoAI) provides a sophisticated content moderation service that enables users to detect harmful text content and PII across multiple policy dimensions, helping to secure LLM applications and ensure safe AI interactions.

## Using F5 Guardrails with Prisma AIRS AI Gateway

### 1. Add F5 Guardrails Credentials to the AI Gateway

* Navigate to the `Plugins` page under `Admin Settings`
* Click on the edit button for the **F5 Guardrails** integration
* Add your **F5 Guardrails API Key** (obtain this from your F5/CalypsoAI account)
* (Optional) Add your F5 Gaurdrail API URL, defaults to [https://us1.calypsoai.app](https://us1.calypsoai.app).

### 2. Add F5 Guardrails Check

* Navigate to the `Guardrails` page and click the `Create` button
* Search for "F5 Guardrails" and click `Add`
* Configure your moderation checks:
  * **Project ID**: Your F5 Guardrails project identifier (Required)
  * **Redact**: Whether to redact PII data detected by the guardrail. When enabled, detected PII will be masked in the content (Default: `false`)
  * **Timeout**: The timeout in milliseconds for the scan (Default: `5000`)
  * **Override Credentials** (optional, Backend `v1.16.0+`): Workspace-specific credentials that override the organisation-level integration. Useful when different workspaces need to use separate F5/CalypsoAI accounts.
    * `apiKey` — workspace-specific F5 Guardrails API key
    * `calypsoUrl` — workspace-specific F5 Guardrails API URL (defaults to `https://us1.calypsoai.app`)
* Set any `actions` you want on your check, and create the Guardrail!

> [!NOTE]
>
> Guardrail Actions allow you to orchestrate your guardrails logic. You can learn more about them [here](https://docs.portkey.ai/docs/aigw/product/guardrails.md#there-are-7-types-of-guardrail-actions)

| Check Name | Description | Parameters | Supported Hooks |
| - | - | - | - |
| F5 Guardrails | Checks content using F5 Guardrails scanner | `Project ID` (string), `Redact` (boolean), `Timeout` (number), `credentials` (object, optional) | `beforeRequestHook`, `afterRequestHook` |

### 3. Add Guardrail ID to a Config and Make Your Request

* When you save a Guardrail, you'll get an associated Guardrail ID - add this ID to the `input_guardrails` or `output_guardrails` params in your AI Gateway Config
* Create these Configs in Strata Cloud Manager, save them, and get an associated Config ID to attach to your requests. [More here](https://docs.portkey.ai/docs/aigw/product/ai-gateway/configs.md).

Here's an example config:

```json theme={"system"}
{
  "input_guardrails": ["guardrails-id-xxx", "guardrails-id-yyy"],
  "output_guardrails": ["guardrails-id-xxx", "guardrails-id-yyy"]
}
```

**cURL**

```sh theme={"system"}
curl https://aigw.portkey.ai/v1/chat/completions \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $OPENAI_API_KEY" \
  -H "x-portkey-api-key: $PORTKEY_API_KEY" \
  -H "x-portkey-config: $CONFIG_ID" \
  -d '{
    "model": "gpt-3.5-turbo",
    "messages": [{
        "role": "user",
        "content": "Hello!"
      }]
  }'
```

**OpenAI NodeJS**

```js theme={"system"}
const openai = new OpenAI({
  apiKey: "PORTKEY_API_KEY",
  baseURL: "https://aigw.portkey.ai/v1",
  defaultHeaders: { "x-portkey-config": "CONFIG_ID" }
});
```

**OpenAI Python**

```py theme={"system"}
client = OpenAI(
    api_key="PORTKEY_API_KEY", # defaults to os.environ.get("OPENAI_API_KEY")
    base_url="https://aigw.portkey.ai/v1",
    default_headers={
        "x-portkey-provider": "openai",
        # defaults to os.environ.get("PORTKEY_API_KEY")
        "x-portkey-config": "CONFIG_ID",
    }
)
```

For more, refer to the [Config documentation](https://docs.portkey.ai/docs/aigw/product/ai-gateway/configs.md).

Your requests are now guarded by F5 Guardrails, and you can see the verdict and any actions taken directly in your AI Gateway logs!


## Related topics

- [Enterprise Gateway](https://docs.portkey.ai/docs/changelog/enterprise.md)
- [List of Guardrail Checks](https://docs.portkey.ai/docs/aigw/product/guardrails/list-of-guardrail-checks.md)
- [Guardrails](https://docs.portkey.ai/docs/aigw/product/guardrails.md)
- [Azure Guardrails](https://docs.portkey.ai/docs/aigw/integrations/guardrails/azure-guardrails.md)


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.